
#include <algorithm>
#include <math.h>

template <typename Iterator>
inline
typename std::iterator_traits<Iterator>::value_type
sum(std::pair<Iterator, Iterator> &p)
{
  return sum(p.first, p.second);
}


template <typename T>
inline
T expsum(T t)
{
  return t;
}

template <typename Itr>
inline
typename std::iterator_traits<Itr>::value_type expsum(Itr begin, Itr end)
{
  typename std::iterator_traits<Itr>::value_type n;
  if (begin == end) {
    empty(n);
    return n;
  }
  assert(!isEmpty(*begin));
  n = exp(*begin);
  ++begin;
  for (; begin != end; ++begin) {
    assert(!isEmpty(*begin));
    n += exp(*begin);
  }
  return log(n);
}

template <typename Iterator>
inline
typename std::iterator_traits<Iterator>::value_type
expsum(std::pair<Iterator, Iterator> &p)
{
  return expsum(p.first, p.second);
}
