/*
 * TCS Alignment Toolbox
 * 
 * Copyright (C) 2013, 2014
 * Benjamin Paaßen, Charlie Krüger, Georg Zentgraf
 * AG Theoretical Computer Science
 * Centre of Excellence Cognitive Interaction Technology (CITEC)
 * University of Bielefeld
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.unibi.citec.tcs.alignment;

import de.unibi.citec.tcs.alignment.sequence.Sequence;
import de.unibi.citec.tcs.alignment.wrappers.StringEditDistance;
import java.util.EnumMap;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 * TODO: THIS IS NOT YET IMPLEMENTED!
 *
 * @author Benjamin Paassen - bpaassen@techfak.uni-bielefeld.de
 */
public class AbstractLocalAlignmentAlgorithmTest {

	public AbstractLocalAlignmentAlgorithmTest() {
	}

	@BeforeClass
	public static void setUpClass() {
	}

	@AfterClass
	public static void tearDownClass() {
	}

	@Before
	public void setUp() {
	}

	@After
	public void tearDown() {
	}

	/**
	 * Test of calculation.
	 */
	@Test
	public void testGetSpecification() {
		final String[] strings = {"ccccccbabcccc", "bab"};
		final Sequence[] seqs = StringEditDistance.toSequences(strings);
		final AlignmentSpecification spec = StringEditDistance.setUpSpecification(seqs);
		final TestImpl instance = new TestImpl(spec);
		Double result = instance.calculateAlignment(seqs[0], seqs[1]);
	}

	

	public class TestImpl extends AbstractLocalAlignmentAlgorithm<Double> {

		public TestImpl(final AlignmentSpecification spec) {
			super(Double.class, spec);
		}

		public double choice(double[] choices) {
			if (choices.length == 0) {
				throw new UnsupportedOperationException("No choices!");
			}
			double min = choices[0];
			for (int i = 1; i < choices.length; i++) {
				if (choices[i] < min) {
					min = choices[i];
				}
			}
			return min;
		}

		@Override
		public Double transformToResult(EnumMap<Recurrence, double[][]> dp_tables,
				Sequence a, Sequence b) {
			return dp_tables.get(Recurrence.SKIPDEL_START)[0][0];
		}

	}

}
