/* 
 * TCS Alignment Toolbox
 * 
 * Copyright (C) 2013, 2014
 * Benjamin Paaßen, Charlie Krüger, Georg Zentgraf
 * AG Theoretical Computer Science
 * Centre of Excellence Cognitive Interaction Technology (CITEC)
 * University of Bielefeld
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.unibi.citec.tcs.alignment;

import de.unibi.citec.tcs.alignment.sequence.Sequence;
import java.util.List;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author bpaassen
 */
public class PathMapTest {

    public PathMapTest() {
    }

    @BeforeClass
    public static void setUpClass() {
    }

    @AfterClass
    public static void tearDownClass() {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of toMatrix method, of class PathMap.
     */
    @Test
    public void testToMatrix() {
        /*
         * we set up a simple input: An alignment of a and a. The optimal
         * alignment obviously is a simple replacement. However two other
         * alignments are possible (even though they are suboptimal): First
         * deleting a and then inserting a or first inserting a and than
         * deleting a.
         */
        final Sequence a = new Sequence("a");
        final Sequence b = new Sequence("a");
        final StrictKPathAlgorithm algo = new StrictKPathAlgorithm(
                new AlignmentSpecification(a));
        final PathMap instance = algo.calculateAlignment(a, b);
        assertEquals(3, instance.getSize());
        //check the resulting matrix.
        final double[][] pseudo_dp_matrix = instance.toMatrix();
        assertEquals(0, pseudo_dp_matrix[0][0], 0);
        assertTrue(pseudo_dp_matrix[0][1] > 0);
        assertEquals(pseudo_dp_matrix[0][1], pseudo_dp_matrix[1][0], 0);
        assertTrue(pseudo_dp_matrix[1][1] > 2 * pseudo_dp_matrix[1][0]);

    }

}
