/* 
 * TCS Alignment Toolbox
 * 
 * Copyright (C) 2013, 2014
 * Benjamin Paaßen, Charlie Krüger, Georg Zentgraf
 * AG Theoretical Computer Science
 * Centre of Excellence Cognitive Interaction Technology (CITEC)
 * University of Bielefeld
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.unibi.citec.tcs.alignment.comparators;

import junit.framework.TestCase;

/**
 *
 * @author Benjamin Paassen - bpaassen(at)techfak.uni-bielefeld.de
 */
public class CharStatComparatorTest extends TestCase {

	public CharStatComparatorTest(String testName) {
		super(testName);
	}

	@Override
	protected void setUp() throws Exception {
		super.setUp();
	}

	@Override
	protected void tearDown() throws Exception {
		super.tearDown();
	}

	/**
	 * Test of distance method, of class CharStatComparator.
	 */
	public void testDistance() {
		assertEquals(0, CharStatComparator.distance("", ""), 0);
		assertEquals(0, CharStatComparator.distance("test", "test"), 0);
		assertEquals(1, CharStatComparator.distance("i", "j"), 0);
		assertEquals(1, CharStatComparator.distance("j", "i"), 0);
		assertEquals(0, CharStatComparator.distance("abc", "bac"), 0);
		assertEquals(0, CharStatComparator.distance("bac", "abc"), 0);
		assertEquals(0.33, CharStatComparator.distance("abc", "abd"), 0.01);
	}
}
